<id>
Smart Image Resize YaBB 2.1
</id>

<version>
Beta 5
</version>

<mod info>
This mod uses javascript to resize avatars, attachments and pictures inserted using the [img] tag if they exceed a maximum size, while maintaining the original aspect ratio of the image.
Original code written by BHRA Webmaster. Every effort has been made to contact BHRA Webmaster in seeking permission to port his mods from 1.3 t YaBB 2.1, but with no response.
Approval has been given by Michael Prager to post this mod.

FYI:
	1 -- The mod below has been converted from 2 YaBB 1.3 mods, the smart_resize_SP12-13 & smart_resize_attachments mods
	2 -- I take credit for the convertion, and not for the logic - this must got to BHRA Webmaster & Michael Prager
	3 -- This mod replaces the option of "User Pic" in Forum Settings with the "Avatar" setting, so as to keep such common functionalities in one area.
	4 -- Laslty, this my first attempt at mod writing, so dont shoot the messenger !!

Notes:
	1 -- The maximum allowed image width and height is now set under the banner of Installed Mods.
	2 -- There are seperate settings for: avatars, attachments, images in messages and images in signatures.
	3 -- The [img] tag can now contain width, height, align and alt attributes in any order or combination.
	4 -- The align attribute can take the standard align values of the <img> tag (left, right, top, texttop, middle, absmiddle, baseline, bottom, absbottom).
	5 -- If you specify the width or height, the image will be resized to that width or height while maintaining the aspect ratio of the original image. 
	6 -- If you specify both the width and height, the image will be resized to the size specified, adopting the specified aspect ratio.
	7 -- If the image exceeds the maximum allowed size, it will be resized to the maximum allowed size while maintaining it's original aspect ratio or the specified aspect ratio.
	8 -- If the users browser does not support javascript, the normal (unresized) image will be displayed.
	9 -- Includes the [img] tag bugfix by Michael Prager, and images are restricted to files with a .gif, .jpg, .png or .bmp extension.

Installation:
	1 -- VERY IMPORTANT that you uninstall any previous versions of this mod
	2 -- Install new version and upload files to their appropiate directory in ASCII.

		AdminIndex.pl
		Admin/ModList.pl
		Admin/Admin.pl
		Admin/AdminSubList.pl
		Admin/AdminEdit.pl
		Templates/default/default.html
		Sources/Display.pl
		Sources/Load.pl
		Sources/Printpage.pl
		Sources/Profile.pl
		Sources/YaBBC.pl

	3. Upload the Smart_Image_Resize.txt file to the Variable directory in ASCII.
	4. Upload the Language files into their repective directories in ASCII.

	Many thanks to Larian - German Translation Language File.
	Many thanks to RuKo - Dutch Translation Language File.

History:
	Beta 1 -- Initial Mod
	Beta 2 -- Resolve issues with avatars not showing. Code inserted to resolve this, into Load.pl file
	Beta 3 -- Re-wrote Mod to conform to BoardMod Mod writing standards - as a Mod under the "Installed Mods" banner in Admin Center
	Beta 4 -- Added German Language File
	Beta 5 -- Added Dutch Language File
</mod info>

<author>
Converted to YaBB 2.1 by Tom Poczman
</author>

<homepage>
http://www.fishsa.com/
</homepage>

###############################################################################

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	### Smart Image Resize mod ###
	$Smart_Image_Resize = "Smart Image Resize|Tom Poczman|This mod uses javascript to resize attachments, avatars and pictures inserted using the [img] tag if they exceed a maximum size, while maintaining the original aspect ratio of the image. Original code by BHRA Webmaster.|Beta 5|06/01/06";
	push (@installed_mods, "$Smart_Image_Resize");
	### Smart Image Resize mod ###
</add before>

###############################################################################

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$Smart_Image_Resize = "smart_image_resize|Smart Image Resize|Smart Image Resize|";
push (@boardmod_mods, "$Smart_Image_Resize");

</add before>

###############################################################################

<edit file>
Templates/default/default.html
</edit file>

<search for>
</head>
</search for>

<add before>
	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function resize_img(thisimage, maxwidth, maxheight, specwidth, specheight) {
		if (document.images) {
			tmp_image = new Image;
			tmp_image.src = thisimage.src;
			var tmpwidth = tmp_image.width;
			var tmpheight = tmp_image.height;

			if (specwidth != 0 && specheight != 0) {
				tmpwidth = specwidth;
				tmpheight = specheight;
			}
			if (specwidth != 0 && specheight == 0) {
				tmpheight = (tmpheight * specwidth / tmpwidth);
				tmpwidth = specwidth;
			}
			if (specwidth == 0 && specheight != 0) {
				tmpwidth = (tmpwidth * specheight / tmpheight);
				tmpheight = specheight;
			}

			if (maxwidth != 0 && tmpwidth > maxwidth) {
				tmpheight = (tmpheight * maxwidth / tmpwidth);
				tmpwidth = maxwidth;
			}

			if (maxheight != 0 && tmpheight > maxheight) {
				tmpwidth = tmpwidth * maxheight / tmpheight;
				tmpheight = maxheight;
			}

			thisimage.width = tmpwidth;
			thisimage.height = tmpheight;
			thisimage.style.display = 'inline';
		}
	}
	// -->
	</script>
</add before>

###############################################################################

<edit file>
Admin/Admin.pl
</edit file>

<search for>
}

1;
</search for>

<replace>
}

### Smart_Image_Resize mod ###
sub Smart_Image_Resize {
	&is_admin_or_gmod;
	LoadLanguage("Smart_Image_Resize");
	require "$vardir/Smart_Image_Resize.txt";
	$yymain .= qq~
<form action="$adminurl?action=smart_image_resize2" method="post">
 <div class="bordercolor" style="padding: 0px; width: 95%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       	<td align="left" class="titlebg" colspan="2"><img src="$imagesdir/guest.gif" alt="" border="0" /> <b>$Smart_Image_Resize_txt{'1'}</b></td>
     </tr>
     <tr valign="middle">
       <td align="left" class="catbg" colspan="2"><span class="small">$Smart_Image_Resize_txt{'8'}</span></td>
     </tr>
     <tr valign="middle">
       <td align="center" class="windowbg2">$Smart_Image_Resize_txt{'2'}</td>
       <td align="center" class="windowbg2">$Smart_Image_Resize_txt{'6'} <input type="text" name="avatar_width" size="5" value="$avatar_width"> &nbsp; &nbsp; $Smart_Image_Resize_txt{'7'} <input type=text name="avatar_height" size="5" value="$avatar_height" /></td>
     </tr>
     <tr valign="middle">
       <td align="center" class="windowbg2">$Smart_Image_Resize_txt{'3'}</td>
       <td align="center" class="windowbg2">$Smart_Image_Resize_txt{'6'} <input type="text" name="MAXIMGWIDTH" size="5" value="$MAXIMGWIDTH"> &nbsp; &nbsp; $Smart_Image_Resize_txt{'7'} <input type=text name="MAXIMGHEIGHT" size="5" value="$MAXIMGHEIGHT" /></td>
     </tr>
     <tr valign="middle">
       <td align="center" class="windowbg2">$Smart_Image_Resize_txt{'4'}</td>
       <td align="center" class="windowbg2">$Smart_Image_Resize_txt{'6'} <input type="text" name="MAXSIGWIDTH" size="5" value="$MAXSIGWIDTH"> &nbsp; &nbsp; $Smart_Image_Resize_txt{'7'} <input type=text name="MAXSIGHEIGHT" size="5" value="$MAXSIGHEIGHT" /></td>
     </tr>
     <tr valign="middle">
       <td align="center" class="windowbg2">$Smart_Image_Resize_txt{'5'}</td>
       <td align="center" class="windowbg2">$Smart_Image_Resize_txt{'6'} <input type="text" name="MAXATTWIDTH" size="5" value="$MAXATTWIDTH"> &nbsp; &nbsp; $Smart_Image_Resize_txt{'7'} <input type=text name="MAXATTHEIGHT" size="5" value="$MAXATTHEIGHT" /></td>
     </tr>
   </table>
 </div>
 <br />

 <div class="bordercolor" style="padding: 0px; width: 95%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
     	<td align="center" class="catbg"><input type="submit" value="$admin_txt{'10'}" /></td>
     </tr>
   </table>
 </div>
</form>~;
	$yymain
	&AdminTemplate;
}

sub Smart_Image_Resize2 {
	&is_admin_or_gmod;

	if ($FORM{'avatar_width'} =~ /\d+/) { $avatar_width = $FORM{'avatar_width'}; }
	else { $avatar_width = 140; }
	if ($FORM{'avatar_height'} =~ /\d+/) { $avatar_height = $FORM{'avatar_height'}; }
	else { $avatar_height = 0; }
	if ($FORM{'MAXIMGWIDTH'} =~ /\d+/)  { $MAXIMGWIDTH  = $FORM{'MAXIMGWIDTH'};  }
	else { $MAXIMGWIDTH = 500; }
	if ($FORM{'MAXIMGHEIGHT'} =~ /\d+/)  { $MAXIMGHEIGHT  = $FORM{'MAXIMGHEIGHT'};  }
	else { $MAXIMGHEIGHT = 0; }
	if ($FORM{'MAXSIGWIDTH'} =~ /\d+/)  { $MAXSIGWIDTH  = $FORM{'MAXSIGWIDTH'};  }
	else { $MAXSIGWIDTH = 500; }
	if ($FORM{'MAXSIGHEIGHT'} =~ /\d+/)  { $MAXSIGHEIGHT  = $FORM{'MAXSIGHEIGHT'};  }
	else { $MAXSIGHEIGHT = 0; }
	if ($FORM{'MAXATTWIDTH'} =~ /\d+/)  { $MAXATTWIDTH  = $FORM{'MAXATTWIDTH'};  }
	else { $MAXATTWIDTH = 500; }
	if ($FORM{'MAXATTHEIGHT'} =~ /\d+/)  { $MAXATTHEIGHT  = $FORM{'MAXATTHEIGHT'};  }
	else { $MAXATTHEIGHT = 0; }

	my $filler  = q~                                                                               ~;
	my $setfile = << "EOF";

########## Image Settings ##########

\$avatar_width = $avatar_width;		# Set pixel size to which the selfselected userpics are resized, 0 disables this limit
\$avatar_height = $avatar_height;		# Set pixel size to which the selfselected userpics are resized, 0 disables this limit
\$MAXIMGWIDTH = $MAXIMGWIDTH;	# Set maximum pixel width for images, 0 disables this limit
\$MAXIMGHEIGHT = $MAXIMGHEIGHT;	# Set maximum pixel height for images, 0 disables this limit
\$MAXSIGWIDTH = $MAXSIGWIDTH;		# Set maximum pixel width for images in the signature, 0 disables this limit
\$MAXSIGHEIGHT = $MAXSIGHEIGHT;	# Set maximum pixel height for images in the signature, 0 disables this limit
\$MAXATTWIDTH = $MAXATTWIDTH;	# Set maximum pixel width for attached images, 0 disables this limit
\$MAXATTHEIGHT = $MAXATTHEIGHT;	# Set maximum pixel height for attached images, 0 disables this limit

1;
EOF

	$setfile =~ s~(.+\;)\s+(\#.+$)~$1 . substr( $filler, 0, (70-(length $1)) ) . $2 ~gem;
	$setfile =~ s~(.{64,}\;)\s+(\#.+$)~$1 . "\n   " . $2~gem;
	$setfile =~ s~^\s\s\s+(\#.+$)~substr( $filler, 0, 70 ) . $1~gem;

	fopen(PICSETTINGS, ">$vardir/Smart_Image_Resize.txt");
	print PICSETTINGS $setfile;
	fclose(PICSETTINGS);

	$yySetLocation = qq~$adminurl~;
	&redirectexit;
}

1;
</replace>

###############################################################################

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
%director=(
</search for>

<add after>
'smart_image_resize',"Admin.pl&Smart_Image_Resize", ### Smart_Image_Resize mod ###
'smart_image_resize2',"Admin.pl&Smart_Image_Resize2", ### Smart_Image_Resize mod ###
</add after>

###############################################################################

<edit file>
Admin/AdminEdit.pl
</edit file>

<search for>
		<div class="setting_cell">$admin_txt{'476'}</div>
		<div class="setting_cell2"><input type="text" name="userpic_width" size="5" value="$userpic_width" /></div>
	<br />
		<div class="setting_cell">$admin_txt{'477'}</div>
		<div class="setting_cell2"><input type="text" name="userpic_height" size="5" value="$userpic_height" /></div>
	<br />
		<div class="setting_cell">$admin_txt{'689'}</div>
		<div class="setting_cell2"><input type="text" name="maxsiglen" size="5" value="$MaxSigLen" /></div>
	<br />
</search for>

<replace>
		<div class="setting_cell">$admin_txt{'689'}</div>
		<div class="setting_cell2"><input type="text" name="maxsiglen" size="5" value="$MaxSigLen" /></div>
	<br />
</replace>

<search for>
	if ($FORM{'userpic_width'} =~ /\d+/) { $userpic_width = $FORM{'userpic_width'}; }
	else { $userpic_width = 65; }
	if ($FORM{'userpic_height'} =~ /\d+/) { $userpic_height = $FORM{'userpic_height'}; }
	else { $userpic_height = 65; }
	$gzcomp       = $FORM{'gzcomp'}       || 0;
</search for>

<replace>
	$gzcomp       = $FORM{'gzcomp'}       || 0;
</replace>

<search for>
########## MemberPic Settings ##########

\$userpic_width = $userpic_width;			# Set pixel size to which the selfselected userpics are resized, 0 disables this limit
\$userpic_height = $userpic_height;			# Set pixel size to which the selfselected userpics are resized, 0 disables this limit


########## File Locking ##########
</search for>

<add after>

########## File Locking ##########
</add after>

###############################################################################

<edit file>
Sources/Display.pl
</edit file>

<search for>
LoadLanguage("Display");
</search for>

<add after>
require "$vardir/Smart_Image_Resize.txt";
</add after>

<search for>
					var userpic_width = $userpic_width;
					var userpic_height = $userpic_height;
</search for>

<replace>
					var userpic_width = $avatar_width;
					var userpic_height = $avatar_height;
</replace>

<search for>
					$showattach   = qq~<div class="scroll" style="max-height: 400px; width: 100%; overflow: auto;" align="center"><img src="$uploadurl/$mfn" alt="$mfn" border="0" /></div>~;
</search for>

<replace>
					$showattach   = qq~<div class="scroll" align="center"><img src="$uploadurl/$mfn" style="display:none" onerror="javascript: this.style.display = 'inline'" onload="javascript: if (this.style.display == 'none') {resize_img(this, $MAXATTWIDTH, $MAXATTHEIGHT, 0, 0)}" alt="$mfn" border="0" /></div>~;
</replace>

###############################################################################

<edit file>
Sources/Printpage.pl
</edit file>

<search for>
	$char_160 = chr(160);
	$threadpost =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~http://$2~isg;
	$threadpost =~ s~\[img width=(\d+) height=(\d+)\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~http://$4~isg;
</search for>

<replace>
	$char_160 = chr(160);
	$threadpost =~ s~\[img(.*?)\](?:\s|\t|\n|&nbsp;|$char_160)*(?:http(s)?\:\/\/)*(.+?)(?:\s|\t|\n|&nbsp;|$char_160)*\[/img\]~http$2://$3~isg;
</replace>

###############################################################################

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
LoadLanguage("Post");
</search for>

<add after>
require "$vardir/Smart_Image_Resize.txt";
</add after>

<search for>
$MAXIMGWIDTH  = 400;
$MAXIMGHEIGHT = 500;

sub restrictimage {
	my ($w, $h, $s) = @_;
	$w = $w <= $MAXIMGWIDTH  ? $w : $MAXIMGWIDTH;
	$h = $h <= $MAXIMGHEIGHT ? $h : $MAXIMGHEIGHT;
	return qq~<img src="$s" width="$w" height="$h" alt="" border="0" />~;
}
</search for>

<replace>
$MAXIMGWIDTH = $MAXIMGWIDTH || 0;
$MAXIMGHEIGHT = $MAXIMGHEIGHT || 0;

sub restrictimage {
	my($tmpstuff,$s) = @_;
	if ($s !~ m/^http(s)?\:\/\/.*\.(gif|jpg|jpeg|png|bmp|GIF|JPG|JPEG|BMP)$/i) {return qq~$s~;}
	my ($dummy, $key, $value, $a, $b, $c);
	undef %parameter;
	foreach $dummy (split(/\s+/, $tmpstuff)) {
		($key, $value) = split(/=/,$dummy);
		&FromHTML($value);
		$parameter{$key} = $value;
	}
	$parameter{'width'} =~ s~\D~~g;
	$parameter{'height'} =~ s~\D~~g;
	$parameter{'align'} =~ s~\W~~g;
	&ToHTML($parameter{'alt'});
	$parameter{'alt'} =~ s~_~ ~g;
	if ($parameter{'align'} eq "") {$a = "";} else {$a = qq~ align="$parameter{'align'}"~;}
	if ($parameter{'width'} eq "") {$b = "";$parameter{'width'} = "0";} else {$b = qq~ width="$parameter{'width'}"~;}
	if ($parameter{'height'} eq "") {$c = "";$parameter{'height'} = "0";} else {$c = qq~ height="$parameter{'height'}"~;}

	return qq~<img src="$s"$a$b$c style="display:none" onerror="javascript: this.style.display = 'inline'" onload="javascript: if (this.style.display == 'none') {resize_img(this, $MAXIMGWIDTH, $MAXIMGHEIGHT, $parameter{'width'}, $parameter{'height'})}" alt="$parameter{'alt'}" border="0">~;
}
</replace>

<search for>
	$char_160  = chr(160);
	$message =~ s~\[img\](?:\s|\t|\n|$hardspace|$char_160)*(http\:\/\/)*(.+?)(?:\s|\t|\n|$hardspace|$char_160)*\[/img\]~<img src="http\:\/\/$2" alt="" border="0" />~isg;
	$message =~ s~\[img width=(\d+) height=(\d+)\](?:\s|\t|\n|$hardspace|$char_160)*(http\:\/\/)*(.+?)(?:\s|\t|\n|$hardspace|$char_160)*\[/img\]~restrictimage($1,$2,'http://'.$4)~eisg;
</search for>

<replace>
	$char_160  = chr(160);
	$message =~ s~\[img(.*?)\](?:\s|\t|\n|&nbsp;|$char_160)*(?:http(s)?\:\/\/)*(.+?)(?:\s|\t|\n|&nbsp;|$char_160)*\[/img\]~restrictimage($1, 'http'.$2.'://'.$3)~eisg;
</replace>

###############################################################################

<edit file>
Sources/Load.pl
</edit file>

<search for>
require "$sourcedir/System.pl";
</search for>

<add after>
require "$vardir/Smart_Image_Resize.txt";
</add after>

<search for>
	if ($enable_ubbc) {
		if (!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
		&DoUBBC;
	}
</search for>

<replace>
	if($enable_ubbc) {
		$tmp_max_width = $MAXIMGWIDTH; $tmp_max_height = $MAXIMGHEIGHT;		# store maximum image size
		$MAXIMGWIDTH = $MAXSIGWIDTH; $MAXIMGHEIGHT = $MAXSIGHEIGHT;		# set limits to maximum signature size
		if (!$yyYaBBCloaded) {
			require "$sourcedir/YaBBC.pl";
		}
		&DoUBBC;
		$MAXIMGWIDTH = $tmp_max_width; $MAXIMGHEIGHT = $tmp_max_height;		# restore maximum image size
	}
</replace>

<search for>
	# Create the userpic / avatar html
	if ($showuserpic && $allowpics) {
		${$uid.$user}{'userpic'} ||= 'blank.gif';
		if (${$uid.$user}{'userpic'} =~ m~\A[\s\n]*http://~i) {
			${$uid.$user}{'userpic'}    = qq~${$uid.$user}{'userpic'}~;
			${$uid.$user}{'userownpic'} = 1;
		} else {
			${$uid.$user}{'userpic'}    = qq~$facesurl/${$uid.$user}{'userpic'}~;
			${$uid.$user}{'userownpic'} = 0;
		}
	} else {
		${$uid.$user}{'userpic'} = '<br />';
	}
</search for>

<replace>
	# Create the userpic / avatar html
	if ($showuserpic && $allowpics) {
		${$uid.$user}{'userpic'} ||= 'blank.gif';
		if (${$uid.$user}{'userpic'} =~ m~\A[\s\n]*http://~i) {
			if ($avatar_width ne 0) { $tmp_width = "width=$avatar_width"; } else { $tmp_width=""; }
			if ($avatar_height ne 0) { $tmp_height = "height=$avatar_height"; } else { $tmp_height=""; }
			$pic .= qq~<img src="${$uid.$user}{'userpic'}" id="avatar" $tmp_width $tmp_height style="display:none" onerror="javascript: this.style.display = 'inline'" onload="javascript: if (this.style.display == 'none') {resize_img(this, $avatar_width, $avatar_height, 0, 0)}" alt="" border="0" /></a>~;

			${$uid.$user}{'userownpic'} = 1;
		} else {
			${$uid.$user}{'userpic'}    = qq~$facesurl/${$uid.$user}{'userpic'}~;
			${$uid.$user}{'userownpic'} = 0;
		}
	} else {
		${$uid.$user}{'userpic'} = '<br />';
	}
</replace>

###############################################################################

<edit file>
Sources/Profile.pl
</edit file>

<search for>
			$pic = qq~<img src="${$uid.$user}{'userpic'}" id="avatar" border="0" alt=""$avstyle />~;
</search for>

<replace>
			if ($avatar_width ne 0) { $tmp_width = "width=$avatar_width"; } else { $tmp_width=""; }
			if ($avatar_height ne 0) { $tmp_height = "height=$avatar_height"; } else { $tmp_height=""; }
			$pic .= qq~<img src="${$uid.$user}{'userpic'}" id="avatar" $tmp_width $tmp_height style="display:none" onerror="javascript: this.style.display = 'inline'" onload="javascript: if (this.style.display == 'none') {resize_img(this, $avatar_width, $avatar_height, 0, 0)}" alt="" border="0" /></a>~;
</replace>